﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        private Socket peer;
        private byte[] buffer = new byte[256];
        public delegate void DelegateSetText(string text);
        public delegate void DelegateSetButtons(bool connectbt, bool sendbt, bool disconnectbt);


        public Form1()
        {
            InitializeComponent();
        }
        //---------------------------------------------------------------------------------------


        private void bt_bind_Click(object sender, EventArgs e)
        {                   
            try
            {
                if ((tb_ip.Text != "") && (tb_local.Text != "") && (tb_port.Text != ""))
                {
                    peer = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
                    IPEndPoint localEP = new IPEndPoint(IPAddress.Parse("0.0.0.0"), int.Parse(tb_local.Text));
                    peer.Bind(localEP);
                    peer.BeginReceive(buffer, 0, 255, SocketFlags.None, new AsyncCallback(receiveCallback), peer);
                    SetButtons(false, true, true);
                    sb_status.Text = "Binded";
                }
                else
                    sb_status.Text = "IP and Port needed";
            }
            catch (SocketException)
            { sb_status.Text = "Binding not possible"; }
        }
        //---------------------------------------------------------------------------------------

    
        private void receiveCallback(IAsyncResult ar)
        {
            string receivetext;
            int bytesRead;
            try
            {
                bytesRead = peer.EndReceive(ar);
                receivetext = string.Empty;
                receivetext = Encoding.ASCII.GetString(buffer);
                SetText(receivetext);
                peer.BeginReceive(buffer, 0, 255, SocketFlags.None, new AsyncCallback(receiveCallback), peer);
            }
            catch (Exception)
            { bytesRead = 0; }
        }
        //---------------------------------------------------------------------------------------


        private void disconnect()
        {
            try
            {   peer.Shutdown(SocketShutdown.Both);
                peer.Close();
                sb_status.Text = "not bindeded";
                SetButtons(true, false, false);
            }
            catch (Exception)
            { sb_status.Text = "Not able to stop binding"; }
        }
        //---------------------------------------------------------------------------------------


        private void bt_send_Click(object sender, EventArgs e)
        {
            IPEndPoint sendtoEP = new IPEndPoint(IPAddress.Parse(tb_ip.Text), int.Parse(tb_port.Text));
            byte[] SendData;
            if (cb_CRLF.Checked)
            {
                SendData = Encoding.ASCII.GetBytes(tb_send.Text + (char)13 + (char)10);
            }
            else
            {
                SendData = Encoding.ASCII.GetBytes(tb_send.Text);
            }
            peer.SendTo(SendData, 0, SendData.Length, SocketFlags.None, sendtoEP);
        }
        //---------------------------------------------------------------------------------------


        private void SetText(string receivetext)
        {
            if (this.InvokeRequired)
            {
                this.Invoke(new DelegateSetText(SetText), receivetext);
            }
            else
            {
                tb_receive.Text += receivetext;
            }
        }
        //---------------------------------------------------------------------------------------


        private void SetButtons(bool bindbt, bool sendbt, bool disconnectbt)
        {
            if (this.InvokeRequired)
            {
                this.Invoke(new DelegateSetButtons(SetButtons), bindbt, sendbt, disconnectbt);
            }
            else
            {
                bt_bind.Enabled = bindbt;
                bt_send.Enabled = sendbt;
                bt_disconnect.Enabled = disconnectbt;
            }
        }
        //---------------------------------------------------------------------------------------


        private void bt_disconnect_Click(object sender, EventArgs e)
        {
            disconnect(); 
        }
        //---------------------------------------------------------------------------------------


    }
}
